# cal_displacement.key : calculate displacement 
#                        (we know the Plain text and the Cipher text)
import sys
import string
# ===================================
def is_maj(car):

        if string.find(string.ascii_uppercase,car) == -1:
                return 0
        else:
                return 1

def litfic( fic ):
        try:
            f = open(fic,"r")
        except IOError:
            print "ERROR: impossible to open ", fic
            sys.exit(1)
        leTexte = f.readlines()
        texteConcat = ""
        f.close()
        for i in range(len(leTexte)):
                ch = leTexte[i]
                ch = ch.upper()
                for j in range(len(ch)):
                        if not is_maj(ch[j]):
                                continue
                        texteConcat = texteConcat + ch[j]
        return texteConcat
# =========================================
if len(sys.argv) < 2:
    print "Syntaxe: python cal_displacement.py cipher_text_file plain_text_file [debug]"
    sys.exit(1)
DEBUG = 0
if len(sys.argv) > 3:
	DEBUG = 1

tab_cle = []

crypto = litfic( sys.argv[1] )
lg1    = len(crypto)
clair  = litfic( sys.argv[2] )
lg2    = len(clair)
lg = lg1
if lg > lg2: lg = lg2

for i in range( lg ):
	lclair = clair[i]
	lcrypto= crypto[i]
        cle = (ord(lclair)-65 + ord(lcrypto)-65 +1)%26
	tab_cle.append( cle )
	if DEBUG:
		print "(%c,%c)" % (lclair,lcrypto),
	print cle ,
print
